<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
    <el-form-item :label="t('mall.selectStore')" prop="shopId">
        <el-select
          v-model="formData.shopId"
          :placeholder="t('mall.selectStore')"
        >
          <el-option
            v-for="item in shopList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('mall.bankName')" prop="bankName">
        <el-input v-model="formData.bankName" :placeholder="t('mall.pleaseEnterBankName')" />
      </el-form-item>
      <el-form-item :label="t('mall.bankCardNumber')" prop="bankCode">
        <el-input v-model="formData.bankCode" :placeholder="t('mall.pleaseEnterBankCardNumber')" />
      </el-form-item>
      <el-form-item :label="t('mall.name')" prop="name">
        <el-input v-model="formData.name" :placeholder="t('mall.pleaseEnterName')" />
      </el-form-item>
      <el-form-item :label="t('mall.phoneNumber')" prop="bankMobile">
        <el-input v-model="formData.bankMobile" :placeholder="t('mall.pleaseEnterPhoneNumber')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{t('common.confirm')}}</el-button>
      <el-button @click="dialogVisible = false">{{t('common.cancel')}}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as UserBankApi from '@/api/mall/store/userBank'
import * as ShopApi from '@/api/mall/store/shop'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  shopId: undefined,
  shopName: undefined,
  uid: undefined,
  type: undefined,
  bankName: undefined,
  name: undefined,
  bankCode: undefined,
  bankMobile: undefined,
  zfbCode: undefined,
  wxCode: undefined,
  zfbImg: undefined,
  wxImg: undefined,
  status: undefined,
  refuse: undefined,
  bankIcon: undefined,
  bankType: undefined
})
const formRules = reactive({
  shopId: [{ required: true, message: t('mall.storeCannotBeEmpty'), trigger: 'blur' }],
  bankName: [{ required: true, message: t('mall.bankNameCannotBeEmpty'), trigger: 'blur' }],
  bankCode: [{ required: true, message: t('mall.bankCardNumberCannotBeEmpty'), trigger: 'blur' }],
  name: [{ required: true, message: t('mall.nameCannotBeEmpty'), trigger: 'blur' }],
  bankMobile: [{ required: true, message: t('mall.phoneNumberCannotBeEmpty'), trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref
const shopList = ref([])
/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  getList()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await UserBankApi.getUserBank(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as UserBankApi.UserBankVO
    if (formType.value === 'create') {
      await UserBankApi.createUserBank(data)
      message.success(t('common.createSuccess'))
    } else {
      await UserBankApi.updateUserBank(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

const getList = async () => {
  try {
    const data = await ShopApi.getShopList()
    shopList.value = data

  } finally {
    
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    shopId: undefined,
    shopName: undefined,
    uid: undefined,
    type: undefined,
    bankName: undefined,
    name: undefined,
    bankCode: undefined,
    bankMobile: undefined,
    zfbCode: undefined,
    wxCode: undefined,
    zfbImg: undefined,
    wxImg: undefined,
    status: undefined,
    refuse: undefined,
    bankIcon: undefined,
    bankType: undefined
  }
  formRef.value?.resetFields()
}
</script>
